;                      COMmunication port MANIPulator
;                    =================================
; 
; Le 11/01/2002 par Thibaut Barthlemy
; 
; Pour toute question ou remarque, n'hsitez pas -> barthib@hotmail.com
; 
; Si vous programmiez un utilitaire de ce genre, aussi modeste soit-il,
; vous y passeriez un certain temps et quelques neurones...
; Ainsi, vous comprenez que si vous souhaitez reprendre une partie de cette
; source, je vous remercierais simplement de me le signaler, pour que j'ai
; consience que mon travail n'a pas t inutile.
; 
; Amusez-vous bien ;)
; 
; Thibaut.


	section ".data"

	xdef	readport
	xdef	writeport



readport:		; short (void)
	bset.b		#6,$60000C
	btst.b		#3,$60000E
	seq		d0
	lsl.w		#8,d0
	btst.b		#2,$60000E
	seq		d0
	and.w		#$0101,d0
	move.b		#$8D,$60000C
	rts



writeport:		; short (char *sequence, short delay)
	bset.b		#6,$60000C
	lea		$60000E,a1
	move.w		8(a7),d1
	mulu		#10,d1
	subq.w		#1,d1
	move.l		4(a7),a0
	moveq		#0,d0
	move.b		(a0)+,d0
	beq.s		writeport_fin
writeport_loop:
	sub.b		#'0',d0
	cmp.b		#3,d0
	bhi.s		writeport_erreur
	move.b		(a1),d2
	or.b		#%00000011,d2
	eor.b		d0,d2
	move.b		d2,(a1)
	move.w		d1,d2
writeport_wait:
	move.b		20(a0),20(a0)
	move.b		40(a0),40(a0)
	move.b		60(a0),60(a0)
	move.b		80(a0),80(a0)
	move.b		100(a0),100(a0)
	dbf		d2,writeport_wait
	move.b		(a0)+,d0
	bne.s		writeport_loop
	bra.s		writeport_fin
writeport_erreur:
	sub.l		4(a7),a0
	move.w		a0,d0
writeport_fin:
	and.b		#%11111100,(a1)
	move.b		#$8D,$60000C
	rts